unit n2_vector;

interface

uses n2_complex;

type tvector=array of double;
	 tvectorc=array  of tcomplex;

function initv(len:longint):tvector;
function initvc(len:longint):tvectorc;
function absv(v:tvector):double;
function absv(v:tvectorc):double;
function addv(v1,v2:tvector):tvector;
function addv(v1:tvector;v2:tvectorc):tvectorc;
function addv(v1:tvectorc;v2:tvector):tvectorc;
function addv(v1,v2:tvectorc):tvectorc;
function subv(v1,v2:tvector):tvector;
function subv(v1:tvector;v2:tvectorc):tvectorc;
function subv(v1:tvectorc;v2:tvector):tvectorc;
function subv(v1,v2:tvectorc):tvectorc;
function mulv(s:double;v:tvector):tvector;
function mulv(v:tvector;s:double):tvector;
function mulv(s:double;v:tvectorc):tvectorc;
function mulv(v:tvectorc;s:double):tvectorc;
function mulv(s:tcomplex;v:tvector):tvectorc;
function mulv(v:tvector;s:tcomplex):tvectorc;
function mulv(s:tcomplex;v:tvectorc):tvectorc;
function mulv(v:tvectorc;s:tcomplex):tvectorc;
function mulv(v1,v2:tvector):double;
function mulv(v1:tvector;v2:tvectorc):tcomplex;
function mulv(v1:tvectorc;v2:tvector):tcomplex;
function mulv(v1,v2:tvectorc):tcomplex;
function cross(v1,v2:tvector):tvector;
function cross(v1:tvector;v2:tvectorc):tvectorc;
function cross(v1:tvectorc;v2:tvector):tvectorc;
function cross(v1,v2:tvectorc):tvectorc;

implementation

uses n2_mathe;

function initv(len:longint):tvector;
var vi:tvector;
begin
  setlength(vi,len);
  initv:=vi;
end;

function initvc(len:longint):tvectorc;
var vi:tvectorc;
begin
  setlength(vi,len);
  initvc:=vi;
end;

function convv2vc(v:tvector):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=initvc(length(v));
  for i:=0 to length(vi)-1 do vi[i]:=setc(v[i],0);
  convv2vc:=vi;
end;

function absv(v:tvector):double;
var s:double;
	i:longint;
begin
  s:=0;
  for i:=0 to length(v)-1 do s:=s+sqr(v[i]);
  absv:=sqrt(s);
end;

function absv(v:tvectorc):double;
var s:double;
	i:longint;
begin
  s:=0;
  for i:=0 to length(v)-1 do s:=s+sqr(v[i].re)+sqr(v[i].im);
  absv:=sqrt(s);
end;

function addv(v1,v2:tvector):tvector;
var vi:tvector;
	i:longint;
begin
  if length(v1)=length(v2) then
  begin
    vi:=initv(length(v1)); 
	for i:=0 to length(vi)-1 do vi[i]:=v1[i]+v2[i];
	addv:=vi;
  end
  else writeln('add: vectors of same size only.');
end;

function addv(v1,v2:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  if length(v1)=length(v2) then
  begin
    vi:=initvc(length(v1)); 
	for i:=0 to length(vi)-1 do vi[i]:=addc(v1[i],v2[i]);
	addv:=vi;
  end
  else writeln('add: vectors of same size only.');
end;

function addv(v1:tvector;v2:tvectorc):tvectorc;
begin
  addv:=addv(convv2vc(v1),v2);
end;

function addv(v1:tvectorc;v2:tvector):tvectorc;
begin
  addv:=addv(v1,convv2vc(v2));
end;

function subv(v1,v2:tvector):tvector;
var vi:tvector;
	i:longint;
begin
  if length(v1)=length(v2) then
  begin
    vi:=initv(length(v1)); 
	for i:=0 to length(vi)-1 do vi[i]:=v1[i]-v2[i];
	subv:=vi;
  end
  else writeln('sub: vectors of same size only.');
end;

function subv(v1,v2:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  if length(v1)=length(v2) then
  begin
    vi:=initvc(length(v1)); 
	for i:=0 to length(vi)-1 do vi[i]:=subc(v1[i],v2[i]);
	subv:=vi;
  end
  else writeln('sub: vectors of same size only.');
end;

function subv(v1:tvector;v2:tvectorc):tvectorc;
begin
  subv:=subv(convv2vc(v1),v2);
end;

function subv(v1:tvectorc;v2:tvector):tvectorc;
begin
  subv:=subv(v1,convv2vc(v2));
end;

function mulv(s:double;v:tvector):tvector;
var vi:tvector;
	i:longint;
begin
  vi:=initv(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=s*v[i];
  mulv:=vi;
end;

function mulv(v:tvector;s:double):tvector;
var vi:tvector;
	i:longint;
begin
  vi:=initv(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=v[i]*s;
  mulv:=vi;
end;

function mulv(s:double;v:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=initvc(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=mulc(s,v[i]);
  mulv:=vi;
end;

function mulv(v:tvectorc;s:double):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=initvc(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=mulc(v[i],s);
  mulv:=vi;
end;

function mulv(s:tcomplex;v:tvector):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=initvc(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=mulc(s,v[i]);
  mulv:=vi;
end;

function mulv(v:tvector;s:tcomplex):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=initvc(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=mulc(v[i],s);
  mulv:=vi;
end;

function mulv(s:tcomplex;v:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=initvc(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=mulc(s,v[i]);
  mulv:=vi;
end;

function mulv(v:tvectorc;s:tcomplex):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  vi:=initvc(length(v)); 
  for i:=0 to length(vi)-1 do vi[i]:=mulc(v[i],s);
  mulv:=vi;
end;

function mulv(v1,v2:tvector):double;
var s:double;
	i:longint;
begin
  if length(v1)=length(v2) then
  begin
    s:=0;
	for i:=0 to length(v1)-1 do s:=s+v1[i]*v2[i];
	mulv:=s;
  end
  else writeln('mulv: vectors of same size only.');
end;

function mulv(v1,v2:tvectorc):tcomplex;
var s:tcomplex;
	i:longint;
begin
  if length(v1)=length(v2) then
  begin
    s:=setc(0,0);
	for i:=0 to length(v1)-1 do s:=addc(s,mulc(conj(v1[i]),v2[i]));
	mulv:=s;
  end
  else writeln('mulv: vectors of same size only.');
end;

function mulv(v1:tvector;v2:tvectorc):tcomplex;
begin
  mulv:=mulv(convv2vc(v1),v2);
end;

function mulv(v1:tvectorc;v2:tvector):tcomplex;
begin
  mulv:=mulv(v1,convv2vc(v2));
end;

function cross(v1,v2:tvector):tvector;
var vi:tvector;
	i:longint;
begin
  if (length(v1)=3) and (length(v2)=3) then
  begin
    vi:=initv(3); 
	for i:=0 to 2 do vi[i]:=v1[(i+1) mod 3]*v2[(i+2) mod 3]-v1[(i+2) mod 3]*v2[(i+1) mod 3];
	cross:=vi;
  end
  else writeln('cross: for two vectors of three elements only.');
end;

function cross(v1,v2:tvectorc):tvectorc;
var vi:tvectorc;
	i:longint;
begin
  if (length(v1)=3) and (length(v2)=3) then
  begin
    vi:=initvc(3); 
	for i:=0 to 2 do vi[i]:=subc(mulc(v1[(i+1) mod 3],v2[(i+2) mod 3]),mulc(v1[(i+2) mod 3],v2[(i+1) mod 3]));
	cross:=vi;
  end
  else writeln('cross: for two vectors of three elements only.');
end;

function cross(v1:tvector;v2:tvectorc):tvectorc;
begin
  cross:=cross(convv2vc(v1),v2);
end;

function cross(v1:tvectorc;v2:tvector):tvectorc;
begin
  cross:=cross(v1,convv2vc(v2));
end;

end.